#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "snake.h"
#include "cube.h"
#include "draw.h"
#include "draw_3d.h"
#include "effect.h"
#include <curses.h>
#include <ncurses.h>
#include <termios.h>
#include "beep.h"
#include "reader.h"

void *cube_updater (unsigned char rs232_cube[8][8]);


static struct termios initial_settings, new_settings;
static int peek_character = -1;

struct Queue SNAKE;


int main (int argc, char **argv)
{

	cube_init();

	pthread_t cube_thread;
	int iret, i, x;

	iret = pthread_create (&cube_thread, NULL, cube_updater, rs232_cube);

	intro();
	//Snake Control	
	//Initialize Screen
	initscr();
	keypad(stdscr, TRUE); //activate cursor buttons
	noecho();	
	cbreak();
	setvoxel(0,0,0); // starting position
	delay_ms(5000);
	fill(0x00);
	
	int ch=0, l=0, j=0, k=0, last=0, p=1, xc, yc, zc, newcandy=1, speed=10000, resetspeed;
	int snakesize=1, start=0, score=0;	
	resetspeed=speed;

	// define direction keys
	char up = getUp();
	char down = getDown();
	char left = getLeft();
	char right = getRight();
	char forward = getForward();
	char backward = getBackward();
	
	printw("Snake 3D - Revised\n");
	printw("Controls:\n");
	printw("Forward:\tUp\t\t/  %c\t\tBackward:\tDown\t\t/  %c\n", forward, backward);
	printw("Left:\t\tLeft\t\t/  %c\t\tRight:\t\tRight\t\t/  %c\n", left, right);
	printw("Up:\t\tPage Up\t\t/  %c\t\tDown:\t\tPage Down\t/  %c\n", up, down);
	printw("Quit:\t\tq\n");

	while (ch!='q') {  // loops until you press 'q'
	//Buttons
	timeout(100);	
	ch = getch();
	if (ch==ERR) {
	ch=last;
	}
	if (start==0) {   // this emptys the char-buffer at the beginning after a reset
		int c;
		c = getch();
	while (c != EOF){
		c = getch();
		ch=0;
		}
	
	}
	if (last!=0) {
	  start=1;
	}

	if(ch == up || ch == KEY_PPAGE) {
		if (k<7) {			
			k++;
			last=up;
		} else {	
			k = 0; // borderless space
		}
	}

	if(ch == down || ch == KEY_NPAGE) {
		if (k>0) {			
			k--;	
			last=down;
			}
			else {
				k = 7;
			}
	}

	if(ch == left || ch == KEY_LEFT) {
		if (j>0) {			
			j--;	
			last=left;
			}
			else {
				j = 7;
			}
	}

	if(ch == right || ch == KEY_RIGHT) {
		if (j<7) {			
			j++;	
			last=right;
			}
			else {
				j = 0;
			}	
	}

	if(ch == forward || ch == KEY_UP) {
		if (l<7) {			
			l++;
			last=forward;	
			}
			else {	
				l = 0;
			}
	}

	if(ch == backward || ch == KEY_DOWN) {
		if (l>0) {			
			l--;	
			last=backward;
			}
			else {
				l = 7;
			}	
	}

		struct Snake *element;
		element=(struct Snake *)malloc(sizeof(struct Snake)*snakesize);	
		(*element).x=l;
		(*element).y=j;
		(*element).z=k;
		while (newcandy==1) {
			xc=rand() % 8;
			yc=rand() % 8;
			zc=rand() % 8;
			if (checkkill(&SNAKE,xc, yc, zc)!=1) {
			newcandy=0;
			}
			if (start==1) {
			score=score+100;
			}
		}
		setvoxel(xc,yc,zc);
		if (l==xc && j==yc && k==zc) {
		pushpop(&SNAKE, element, 1, speed);
		snakesize++;
		speed=speed/2;
		newcandy=1;
		beeper("e");
		}
		else {
			if (checkkill(&SNAKE, l,j,k) && start==1) {  // Check if you crash into snake
				reset(&SNAKE, score);
				last=0;
				l=0, j=0, k=0;
				speed=resetspeed;
				newcandy=1;	
				start=0;
				score=0;	
				snakesize=1;
				
			}
			pushpop(&SNAKE, element, 0, speed);
			//if (start==1) {
			//score=score + snakesize;
			//}
		}
			
		
	}

	/*
	free (up);
	free (down);
	free (left);
	free (right);
	free (forward);
	free (backward);
	*/

	endwin();
	return 0;

	
}

void *cube_updater (unsigned char rs232_cube[8][8])
{
    unsigned char pushcube[8][8];


	while (1)
    {
        memcpy(pushcube, rs232_cube, 64);
		cube_push(pushcube);
    }
}


