/************************************************************************************************************
* 					SNAKE 3D on 8x8x8 LED CUBE					    *
*													    *
* COPYRIGHT: Simon Bilgeri, Germany									    *
* YEAR: 2012												    *
* YOUTUBE: http://www.youtube.com/watch?v=OBjLsvXdw9o 							    *
* LICENCE: http://creativecommons.org/licenses/by-nc-sa/3.0/ 						    *
*													    *
*************************************************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "snake.h"
#include "draw.h"
#include "effect.h"
#include "beep.h"

/* pushpop adds the new voxel at the front and  deletes the last voxel
   if expand is true -> the last voxel is not deleted*/
void pushpop(struct Queue *queue, struct Snake *new, int expand, int speed) {
	if (queue->front==NULL && queue->back==NULL) {
		queue->front=new;
		queue->back=new;
		new->prev=NULL;
	}
	else {
		queue->front->prev=new;
		queue->front=new;
		new->prev=NULL;
		if (expand==0) {
		queue->back=queue->back->prev;
		}
		else {
		}
	}
	struct Snake *buffer=NULL;	
	buffer=queue->back;
	while (buffer!=NULL) {
	setvoxel((*buffer).x, (*buffer).y, (*buffer).z);
	buffer=buffer->prev;	
	}
	delay_ms(speed);
	fill(0x00);
}
// resets the game after a crash, displays Highscore
void reset(struct Queue *queue, int score) {
		int y_n;		
		queue->front=NULL;
		queue->back=NULL;
		clear();
		if (highscore('c', score)==1) {
		printw("NEW HIGHSCORE!!! %i POINTS\n", score);
		beeper("h");
		fireworks(4,50,800);
		char str[15];
		sprintf(str, "%d", score);
		effect_stringfly2(str, 1500);	
		}	
		else {	
		beeper("c");
		printw("YOUR SCORE IS: %i POINTS!\n\n", score);
		int high;
		high=highscore('r',0);
		printw("THE HIGHSCORE IS: %i POINTS.\n", high);		
		printw("COME ON, YOU CAN DO BETTER!\n\n");
		sleep(2);
		}
		
}
//  checks wheter the user crashes into the Snake itself
int checkkill(struct Queue *queue, int x, int y, int z) {
	struct Snake *buffer=NULL;	
	buffer=queue->back;
	while (buffer!=NULL) {
	if ((*buffer).x==x && (*buffer).y==y && (*buffer).z==z) {
	return (1);
	}
	buffer=buffer->prev;
	}
}
// read, write and check the highscore
int highscore (char mode, int score) {
FILE *datei;
char buffer[30];
int high;
switch (mode) {
	case 'w': 
		datei = fopen ("highscore" , "w");
		fprintf(datei, "%i",score);
		fclose(datei);
		break;
	case 'r': 
	
		datei = fopen ("highscore" , "r");
		fgets(buffer, 30, datei);
		high=atoi(buffer);
		fclose(datei);
		return high;
	
	
		break;
	case 'c': 
		high=highscore('r', score);
		if (score>high) {
		highscore('w', score);
		return 1;
		}
		else {
		return 0;
		}
		break;
	}
}
// INTRO
int intro() {
//system("./beep/intro.sh &");
beeper("i");
effect_stringfly2("SNAKE 3D", 1300);
effect_stringfly2("- Revised", 600);	
}

